#pragma section REPRO
/**
 * @file  divided_cmd_utility.c
 * @brief R}hT|[gUtil
 * @note  HOW TO USE
 *        1. eCmdɂď߂ DCU_check_in sC݂̎s󋵂擾
 *        2. sI ēxċAKvꍇ DCU_register_next œo^
 *        3. ׂĂ̏Iꍇ DCU_report_finish s
 *        4. s̃G[ DCU_report_err ŕ񍐂Dƒf
 *        5. fƂ DCU_abort_cmd s
 *        6. fꂽԂZbgꍇ DCU_donw_abort_flag s
 * @note  telemetry_manager ȂǂŎgĂ̂ŁCQƂ̂
 */
#include "divided_cmd_utility.h"
#include "../CmdTlm/packet_handler.h"
#include "../CmdTlm/common_tlm_cmd_packet_util.h"
#include "../Library/endian_memcpy.h"
#include "../System/TimeManager/time_manager.h"
#include "../System/EventManager/event_logger.h"

/**
 * @brief  App֐
 * @param  void
 * @return void
 */
static void DCU_init_(void);

/**
 * @brief  ONA
 * @param  void
 * @return void
 */
static void DCU_clear_log_(void);

/**
 * @brief  ONAiPvfj
 * @param[in]  log_idx:  O
 * @param[in]  cmd_code: ݒ肷R}hID
 * @return void
 */
static void DCU_clear_log_element_(uint8_t log_idx, CMD_CODE cmd_code);

/**
 * @brief  YR}h̃O擾
 * @param[in]  cmd_code: TR}h
 * @param[out] log_idx:  exec_logs ɂ郍Ȍꏊ
 * @param[out] sort_key: exec_log_order ɂ郍Ȍꏊ
 * @retval DCU_LOG_ACK_OK:        
 * @retval DCU_LOG_ACK_NOT_FOUND: 炸
 */
static DCU_LOG_ACK DCU_search_log_(CMD_CODE cmd_code, uint8_t* log_idx, uint8_t* sort_key);

/**
 * @brief  YR}h̃OCO̐擪ɏo
 * @note   OȂ insert 
 * @param[in]  cmd_code: 擪ɏoR}h
 * @return void
 */
static void DCU_move_to_front_in_log_(CMD_CODE cmd_code);

/**
 * @brief  擪ɊYR}h̃O
 * @note   łÂOj邱Ƃɒ
 * @note   łɃOꍇ`FbN insert DłɃ`FbNĂ邱ƂOƂIII
 * @param[in]  cmd_code: 擪ɍR}h
 * @return void
 */
static void DCU_create_log_on_front_(CMD_CODE cmd_code);


static DividedCmdUtility divided_cmd_utility_;
const DividedCmdUtility* const divided_cmd_utility = &divided_cmd_utility_;

static uint8_t DCU_exec_log_order_temp_[DCU_LOG_MAX];
static CTCP DCU_packet_;


AppInfo DCU_create_app(void)
{
  return create_app_info("divided_cmd_utility", DCU_init_, NULL);
}


static void DCU_init_(void)
{
  DCU_clear_log_();
}


static void DCU_clear_log_(void)
{
  uint8_t i;
  for (i = 0; i < DCU_LOG_MAX; ++i)
  {
    DCU_clear_log_element_(i, Cmd_CODE_MAX);
    divided_cmd_utility_.exec_log_order[i] = i;
  }
}


static void DCU_clear_log_element_(uint8_t log_idx, CMD_CODE cmd_code)
{
  divided_cmd_utility_.exec_logs[log_idx].cmd_code = cmd_code;
  divided_cmd_utility_.exec_logs[log_idx].status = DCU_STATUS_FINISHED;
  divided_cmd_utility_.exec_logs[log_idx].exec_counter = 0;
  divided_cmd_utility_.exec_logs[log_idx].last_exec_sts = CCP_EXEC_SUCCESS;
  divided_cmd_utility_.exec_logs[log_idx].last_exec_time = OBCT_create(0, 0, 0);
}


static DCU_LOG_ACK DCU_search_log_(CMD_CODE cmd_code, uint8_t* log_idx, uint8_t* sort_key)
{
  uint8_t i;
  *log_idx = 0;
  *sort_key = 0;

  for (i = 0; i < DCU_LOG_MAX; ++i)
  {
    uint8_t idx = divided_cmd_utility_.exec_log_order[i];
    if (divided_cmd_utility_.exec_logs[idx].cmd_code == cmd_code)
    {
      *log_idx  = idx;
      *sort_key = i;
      return DCU_LOG_ACK_OK;
    }
  }

  return DCU_LOG_ACK_NOT_FOUND;
}


static void DCU_move_to_front_in_log_(CMD_CODE cmd_code)
{
  uint8_t i;
  uint8_t log_idx;
  uint8_t sort_key;
  DCU_LOG_ACK log_ret = DCU_search_log_(cmd_code, &log_idx, &sort_key);

  if (log_ret == DCU_LOG_ACK_NOT_FOUND)
  {
    // OȂ̂ō
    DCU_create_log_on_front_(cmd_code);
    return;
  }

  for (i = sort_key; i > 0; --i)
  {
    divided_cmd_utility_.exec_log_order[i] = divided_cmd_utility_.exec_log_order[i - 1];
  }
  divided_cmd_utility_.exec_log_order[0] = log_idx;
}


static void DCU_create_log_on_front_(CMD_CODE cmd_code)
{
  uint8_t i;
  uint8_t idx;

  // łÂO擾
  idx = divided_cmd_utility_.exec_log_order[DCU_LOG_MAX - 1];
  if (divided_cmd_utility_.exec_logs[idx].status == DCU_STATUS_PROGRESS)
  {
    EL_record_event((EL_GROUP)EL_CORE_GROUP_DCU,
                    (uint32_t)divided_cmd_utility_.exec_logs[idx].cmd_code,
                    EL_ERROR_LEVEL_HIGH,
                    (uint32_t)divided_cmd_utility_.exec_logs[idx].exec_counter);
  }

  for (i = (DCU_LOG_MAX - 1); i > 0; --i)
  {
    divided_cmd_utility_.exec_log_order[i] = divided_cmd_utility_.exec_log_order[i - 1];
  }
  divided_cmd_utility_.exec_log_order[0] = idx;

  DCU_clear_log_element_(idx, cmd_code);
}


DCU_STATUS DCU_check_in(CMD_CODE cmd_code, uint16_t* exec_counter)
{
  uint8_t idx;
  DCU_STATUS status;

  DCU_move_to_front_in_log_(cmd_code);
  idx = divided_cmd_utility_.exec_log_order[0];  // g̃OidxC܂łVOidxE
  status = divided_cmd_utility_.exec_logs[idx].status;

  if (status == DCU_STATUS_FINISHED)
  {
    DCU_clear_log_element_(idx, cmd_code);
  }
  else if (status == DCU_STATUS_PROGRESS)
  {
    divided_cmd_utility_.exec_logs[idx].exec_counter++;
  }
  else
  {
    // ȂɂȂ
  }

  divided_cmd_utility_.exec_logs[idx].last_exec_time = TMGR_get_master_clock();
  *exec_counter = divided_cmd_utility_.exec_logs[idx].exec_counter;
  return status;
}


DCU_ACK DCU_register_next(CMD_CODE cmd_code, const uint8_t* param, uint16_t len)
{
  uint8_t idx;
  CTCP_UTIL_ACK ret;

  DCU_move_to_front_in_log_(cmd_code);
  idx = divided_cmd_utility_.exec_log_order[0];
  divided_cmd_utility_.exec_logs[idx].status = DCU_STATUS_PROGRESS;

  ret = CCP_form_rtc(&DCU_packet_, cmd_code, param, len);
  if (ret != CTCP_UTIL_ACK_OK) return DCU_ACK_ERR;
  if (PH_analyze_packet(&DCU_packet_) != PH_REGISTERED)
  {
    return DCU_ACK_ERR;
  }

  return DCU_ACK_OK;
}


void DCU_report_finish(CMD_CODE cmd_code, CCP_EXEC_STS last_exec_sts)
{
  uint8_t idx;

  DCU_move_to_front_in_log_(cmd_code);
  idx = divided_cmd_utility_.exec_log_order[0];

  divided_cmd_utility_.exec_logs[idx].status = DCU_STATUS_FINISHED;
  divided_cmd_utility_.exec_logs[idx].last_exec_sts = last_exec_sts;
}


void DCU_report_err(CMD_CODE cmd_code, CCP_EXEC_STS last_exec_sts)
{
  uint8_t idx;

  DCU_move_to_front_in_log_(cmd_code);
  idx = divided_cmd_utility_.exec_log_order[0];

  divided_cmd_utility_.exec_logs[idx].status = DCU_STATUS_ABORTED_BY_ERR;
  divided_cmd_utility_.exec_logs[idx].last_exec_sts = last_exec_sts;
}


void DCU_donw_abort_flag(CMD_CODE cmd_code)
{
  uint8_t idx;

  DCU_move_to_front_in_log_(cmd_code);
  idx = divided_cmd_utility_.exec_log_order[0];

  DCU_clear_log_element_(idx, cmd_code);
}


void DCU_abort_cmd(CMD_CODE cmd_code)
{
  uint8_t idx;

  DCU_move_to_front_in_log_(cmd_code);
  idx = divided_cmd_utility_.exec_log_order[0];

  divided_cmd_utility_.exec_logs[idx].status = DCU_STATUS_ABORTED_BY_CMD;
}


DCU_LOG_ACK DCU_search_and_get_log(CMD_CODE cmd_code, const DCU_ExecStatus* exec_log)
{
  uint8_t log_idx;
  uint8_t sort_key;
  DCU_LOG_ACK log_ret = DCU_search_log_(cmd_code, &log_idx, &sort_key);

  if (log_ret == DCU_LOG_ACK_NOT_FOUND)
  {
    return DCU_LOG_ACK_NOT_FOUND;
  }

  exec_log = &divided_cmd_utility_.exec_logs[log_idx];
  return DCU_LOG_ACK_OK;
}


CCP_EXEC_STS Cmd_DCU_ABORT_CMD(const CTCP* packet)
{
  const uint8_t* param = CCP_get_param_head(packet);
  uint16_t temp;
  CMD_CODE target_cmd;

  // CMD_CODE  u16 Ƒz肷
  if (CCP_get_param_len(packet) != 2) return CCP_EXEC_ILLEGAL_LENGTH;

  endian_memcpy(&temp, param, 2);
  target_cmd = (CMD_CODE)temp;

  DCU_abort_cmd(target_cmd);

  return CCP_EXEC_SUCCESS;
}


CCP_EXEC_STS Cmd_DCU_DOWN_ABORT_FLAG(const CTCP* packet)
{
  const uint8_t* param = CCP_get_param_head(packet);
  uint16_t temp;
  CMD_CODE target_cmd;

  // CMD_CODE  u16 Ƒz肷
  if (CCP_get_param_len(packet) != 2) return CCP_EXEC_ILLEGAL_LENGTH;

  endian_memcpy(&temp, param, 2);
  target_cmd = (CMD_CODE)temp;

  DCU_donw_abort_flag(target_cmd);

  return CCP_EXEC_SUCCESS;
}


CCP_EXEC_STS Cmd_DCU_CLEAR_LOG(const CTCP* packet)
{
  (void)packet;

  DCU_clear_log_();

  return CCP_EXEC_SUCCESS;
}

#pragma section
