/**
 * @file  telemetry_manager.h
 * @brief useregl܂TLhC܂CDHȂǂegǗ₷邽߂App
 * @note  https://gitlab.com/ut_issl/c2a/c2a_core_oss/-/issues/81  telemetry_manager.h ̍ŉQƁiFIXME: ƂdocumentɈڂj
 */
#ifndef TELEMETRY_MANAGER_H_
#define TELEMETRY_MANAGER_H_

#include "../System/ApplicationManager/app_info.h"
#include "../CmdTlm/common_tlm_cmd_packet.h"
#include "../CmdTlm/common_tlm_cmd_packet_util.h"
#include "../CmdTlm/block_command_table.h"


#define TLM_MGR_USE_BC_NUM            (10)    //!< pBC̐D{I10Œz
#define TLM_MGR_MAX_TLM_NUM_PER_BC    (10)    //!< 1BCɉ̃eR}ho^ł邩D{I10Œz


#if BCT_MAX_CMD_NUM < TLM_MGR_MAX_TLM_NUM_PER_BC       // FIXME: BCTȂ
#error BCT_MAX_CMD_NUM is not enough for TelemetryManager
#endif


/**
 * @enum   TLM_MGR_ERR_CODE
 * @note   uint8_t z
 * @brief  ėpG[R[h
 */
typedef enum
{
  TLM_MGR_ERR_CODE_OK,
  TLM_MGR_ERR_CODE_MASTER_DUPLICATED,      //!< BC s masterƂȂ BC dĂ
  TLM_MGR_ERR_CODE_MASTER_IS_ABSENT,       //!< BC s masterƂȂ BC ݂Ȃ
  TLM_MGR_ERR_CODE_REGISTER_INFO_BC_FULL,  //!< RegisterInfo ɂȏ BC o^łȂ
  TLM_MGR_ERR_CODE_CMD_FULL,               //!< ȏeR}ho^łȂ
  TLM_MGR_ERR_CODE_OTHER_ERR,              //!< ̑̃G[
} TLM_MGR_ERR_CODE;


/**
 * @enum   TLM_MGR_BC_TYPE
 * @note   uint8_t z
 * @brief  BC̃^CvDɂĎsʂς
 */
typedef enum
{
  TLM_MGR_BC_TYPE_MASTER,
  TLM_MGR_BC_TYPE_HK_TLM,
  TLM_MGR_BC_TYPE_SYSTEM_TLM,
  TLM_MGR_BC_TYPE_HIGH_FREQ_TLM,
  TLM_MGR_BC_TYPE_LOW_FREQ_TLM,
  TLM_MGR_BC_TYPE_RESERVE,
} TLM_MGR_BC_TYPE;


/**
 * @struct TLM_MGR_BcInfo
 * @brief  BC̏
 */
typedef struct
{
  bct_id_t        bc_id;
  TLM_MGR_BC_TYPE bc_type;
} TLM_MGR_BcInfo;


/**
 * @struct TLM_MGR_RegisterInfo
 * @brief  ǂBCǗCeR}ho^CĂ̏
 * @note   TLM_MGR_BcInfo ̏񂩂琶
 */
typedef struct
{
  uint8_t bc_info_idx[TLM_MGR_USE_BC_NUM];             //!< bc_info ̂ǂ idx  BC gDstaticmۂ̂߁Cő吔 TLM_MGR_USE_BC_NUM ̔zm
  uint8_t bc_info_idx_used_num;                        //!< gpĂ BC 
  uint8_t tlm_register_pointer_to_idx_of_bc_info_idx;  //!< ɃeR}ho^ꍇɎgp bc_info_idx ̔z idx
  uint8_t tlm_register_pointer_to_bc_cmd_idx;          //!< ɃeR}ho^ꍇɓo^BC pos.cmd
} TLM_MGR_RegisterInfo;


/**
 * @struct TelemetryManager
 * @brief  TelemetryManager  AppInfo\
 */
typedef struct
{
  TLM_MGR_BcInfo bc_info[TLM_MGR_USE_BC_NUM];
  struct
  {
    TLM_MGR_RegisterInfo master;          //!< BCŜWJĂ master BC
    TLM_MGR_RegisterInfo hk_tlm;          //!< HK ei1 Hzj
    TLM_MGR_RegisterInfo system_tlm;      /*!< SnsystemœĂtlmi1 Hzj
                                               usertlmDǉ̉e󂯂Ȃ
                                               ɂāCtlm̑S̊ǗeՂɂȂ  */
    TLM_MGR_RegisterInfo high_freq_tlm;   //!< user ei1 Hzj
    TLM_MGR_RegisterInfo low_freq_tlm;    //!< user ei1/10 Hzj
    TLM_MGR_RegisterInfo reserve;         //!< gĂȂBCD̂Ȃ̂ŁCo͍邪eR}h͓o^Ȃ
  } register_info;
  bct_id_t master_bc_id;
  uint8_t is_inited;                      //!< Ă邩H
} TelemetryManager;


extern const TelemetryManager* const telemetry_manager;

AppInfo TLM_MGR_create_app(void);


/**
 * @brief 
 */
CCP_EXEC_STS Cmd_TLM_MGR_INIT(const CTCP* packet);

/**
 * @brief master bc ̏
 */
CCP_EXEC_STS Cmd_TLM_MGR_INIT_MASTER_BC(const CTCP* packet);

/**
 * @brief HKe
 */
CCP_EXEC_STS Cmd_TLM_MGR_CLEAR_HK_TLM(const CTCP* packet);

/**
 * @brief systeme
 */
CCP_EXEC_STS Cmd_TLM_MGR_CLEAR_SYSTEM_TLM(const CTCP* packet);

/**
 * @brief high_freq_tlm, low_freq_tlm 
 * @note  ֋X TLM_MGR_BC_TYPE_RESERVE  BC Ă܂
 */
CCP_EXEC_STS Cmd_TLM_MGR_CLEAR_USER_TLM(const CTCP* packet);

/**
 * @brief TLMoJn
 * @note  master bc ̖ Cmd_TLCD_DEPLOY_BLOCK ɂ deploy block Ă邾
 */
CCP_EXEC_STS Cmd_TLM_MGR_START_TLM(const CTCP* packet);

/**
 * @brief TLMoꎞ~
 * @note  master bc ̖ Cmd_TLCD_DEPLOY_BLOCK  NOP ɍւĂ邾
 * @note  Cmd_TLCD_CLEAR_ALL_TIMELINE / Cmd_TLM_MGR_CLEAR_TLM_TL Ƒ̂̂Ă܂
 * @note  Cmd_TLCD_CLEAR_ALL_TIMELINE / Cmd_TLM_MGR_CLEAR_TLM_TL ̂قK؂ȏꍇ̂ł悭l邱
 */
CCP_EXEC_STS Cmd_TLM_MGR_STOP_TLM(const CTCP* packet);

/**
 * @brief TLMopTLNA
 * @note  Cmd_TLCD_CLEAR_ALL_TIMELINE Ă邾
 * @note  Cmd_TLCD_CLEAR_ALL_TIMELINE GS瑗ĂC TL No }WbNio[ɂȂ̂ŁD
 */
CCP_EXEC_STS Cmd_TLM_MGR_CLEAR_TLM_TL(const CTCP* packet);

/**
 * @brief HKeo^
 */
CCP_EXEC_STS Cmd_TLM_MGR_REGISTER_HK_TLM(const CTCP* packet);

/**
 * @brief systemeo^
 */
CCP_EXEC_STS Cmd_TLM_MGR_REGISTER_SYSTEM_TLM(const CTCP* packet);

/**
 * @brief high_freq_tlm o^
 */
CCP_EXEC_STS Cmd_TLM_MGR_REGISTER_HIGH_FREQ_TLM(const CTCP* packet);

/**
 * @brief low_freq_tlm o^
 */
CCP_EXEC_STS Cmd_TLM_MGR_REGISTER_LOW_FREQ_TLM(const CTCP* packet);


// TODO: Ȃݒ肪ς̂ł͂ȂCݒύX  fCɂD
// CCP_EXEC_STS Cmd_TLM_MGR_APPLY(const CTCP* packet);


// *** HOW TO USE ***
/*
1. FCmd_TLM_MGR_INIT
  - BC邽߁CApp̏ł͌_łłȂ̂ŁCIɏKv
    - initial SLɂĂ
2. 񃆁[U[e̓o^
  - HK, SYSTEM TLMo^Ă ( Cmd_TLM_MGR_REGISTER_HOGE  )
3. eoJn
  - ͔Ö Cmd_TLM_MGR_CLEAR_TLM_TL āCTL2
  - Cmd_TLM_MGR_START_TLM ɂăeoJn
    - ~߂̂ Cmd_TLM_MGR_STOP_TLM
4. Cmd_TLM_MGR_REGISTER_HIGH_FREQ_TLM / Cmd_TLM_MGR_REGISTER_LOW_FREQ_TLM ɂāC1 Hz, 1/10 Hz ̃[U[eelDɓo^ł
5. I Cmd_TLM_MGR_CLEAR_USER_TLM āC[U[e
6. ɎglC4.JԂ

*/

#endif
