#pragma section REPRO
#include "timeline_command_dispatcher.h"

#include <string.h> // for memcpy

#include <src_user/Library/utility.h>
#include "../CmdTlm/packet_handler.h"
#include "../System/TimeManager/time_manager.h"
#include "../System/AnomalyLogger/anomaly_logger.h"
#include "../System/EventManager/event_logger.h"
#include "../Library/endian_memcpy.h"

static CommandDispatcher timeline_command_dispatcher_[TL_ID_MAX];
const CommandDispatcher* const timeline_command_dispatcher = timeline_command_dispatcher_;

static int TLCD_line_no_for_tlm_;
const int* TLCD_line_no_for_tlm;
static cycle_t TLCD_tl_tlm_updated_at_;
const cycle_t* TLCD_tl_tlm_updated_at;
static CTCP TLCD_null_packet_;
const CTCP* TLCD_tl_list_for_tlm[PH_TL0_CMD_LIST_MAX]; // TL0ŒȂ̂łɍ킹B
static int TLCD_page_no_;
const int* TLCD_page_no;

static void TLCD0_init_(void);
static void TLCD0_dispatch_(void);
static void TLCD1_init_(void);
static void TLCD1_dispatch_(void);
static void TLCD2_init_(void);
static void TLCD2_dispatch_(void);
static void tlc_dispatcher_(int line_no);
static PH_ACK drop_tl_cmd_at_(int line_no, cycle_t time);

AppInfo TLCD0_create_app(void)
{
  return create_app_info("tlc0d",
                         TLCD0_init_,
                         TLCD0_dispatch_);
}

static void TLCD0_init_(void)
{
  // TLC0 Dispatcheȑ
  timeline_command_dispatcher_[0] = CDIS_init(&(PH_tl_cmd_list[0]));

  // ^CCR}h̃egϐݒ
  // ׂẴ^CCŋpȂ̂TL0ő\ď
  TLCD_line_no_for_tlm = &TLCD_line_no_for_tlm_;
  TLCD_line_no_for_tlm_ = 0;
  TLCD_tl_tlm_updated_at = &TLCD_tl_tlm_updated_at_;
  memset(&TLCD_null_packet_, 0, sizeof(TLCD_null_packet_));
  TLCD_update_tl_list_for_tlm(0);

  // egy[Wԍl0ɐݒ
  TLCD_page_no_ = 0;
  TLCD_page_no = &TLCD_page_no_;
}

static void TLCD0_dispatch_(void)
{
  tlc_dispatcher_(0);
}

AppInfo TLCD1_create_app(void)
{
  return create_app_info("tlc1d",
                         TLCD1_init_,
                         TLCD1_dispatch_);
}

static void TLCD1_init_(void)
{
  timeline_command_dispatcher_[1] = CDIS_init(&(PH_tl_cmd_list[1]));
}

static void TLCD1_dispatch_(void)
{
  tlc_dispatcher_(1);
}

AppInfo TLCD2_create_app(void)
{
  return create_app_info("tlc2d",
                         TLCD2_init_,
                         TLCD2_dispatch_);
}

static void TLCD2_init_(void)
{
  timeline_command_dispatcher_[2] = CDIS_init(&(PH_tl_cmd_list[2]));
}

static void TLCD2_dispatch_(void)
{
  tlc_dispatcher_(2);
}

static void tlc_dispatcher_(int line_no)
{
  PL_ACK ack = PL_check_tl_cmd(&(PH_tl_cmd_list[line_no]),
                               (size_t)(TMGR_get_master_total_cycle()));

  switch (ack)
  {
  case PL_TLC_ON_TIME:
    // s\莞傤
    CDIS_dispatch_command(&timeline_command_dispatcher_[line_no]);
    break;

  case PL_TLC_PAST_TIME:

    // s\莞
    if (timeline_command_dispatcher_[line_no].lockout == 0)
    {
      // Lockout̏ꍇ̓Am}[L^B
      // LockoutL̏ꍇ̓Am}[̘AhߎߏԂłAm}[L^ȂB
#ifndef AL_DISALBE_AT_C2A_CORE
      AL_add_anomaly(AL_CORE_GROUP_TLCD, (uint32_t)line_no);
#endif
      EL_record_event((EL_GROUP)EL_CORE_GROUP_TLCD_PAST_TIME,
                      (uint32_t)line_no,
                      EL_ERROR_LEVEL_LOW,
                      (uint32_t)CCP_get_ti(&PL_get_head(&PH_tl_cmd_list[line_no])->packet));

      if (timeline_command_dispatcher_[line_no].stop_on_error == 1)
      {
        // LockoutSOEL̏ꍇ
        // LockoutLƂA^CCR}h~B
        timeline_command_dispatcher_[line_no].lockout = 1;
      }
    }

    // R}hsĂяoB
    // LockoutƂȂꍇ͌ĂяoĂR}h͎sȂB
    CDIS_dispatch_command(&timeline_command_dispatcher_[line_no]);
    break;

  case PL_TLC_NOT_YET:
    // sׂR}hȂB
    break;

  default:
    break;
  }
}

uint8_t TLCD_update_tl_list_for_tlm(uint8_t line_no)
{
  PL_Node* pos;
  int i;

  if (line_no >= TL_ID_MAX) return TL_ID_MAX;

  pos = (PL_Node*)PL_get_head(&(PH_tl_cmd_list[line_no]));
  // e񐶐L^
  TLCD_tl_tlm_updated_at_ = TMGR_get_master_total_cycle();

  // SXgeNA
  for (i = 0; i < PH_TL0_CMD_LIST_MAX; ++i)
  {
    TLCD_tl_list_for_tlm[i] = &TLCD_null_packet_;
  }

  // o^ĂTLR}hXgɏ
  for (i = 0; pos != NULL; ++i)
  {
    TLCD_tl_list_for_tlm[i] = &(pos->packet);
    pos = pos->next;
  }

  return line_no;
}

CCP_EXEC_STS Cmd_TLCD_CLEAR_ALL_TIMELINE(const CTCP* packet)
{
  int line_no;

  line_no = CCP_get_param_head(packet)[0];

  if (line_no >= TL_ID_MAX)
  {
    // w肳ꂽCԍ݂Ȃꍇُ͈픻
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  CDIS_clear_command_list(&timeline_command_dispatcher_[line_no]);
  return CCP_EXEC_SUCCESS;
}

CCP_EXEC_STS Cmd_TLCD_CLEAR_TIMELINE_AT(const CTCP* packet)
{
  const unsigned char* param = CCP_get_param_head(packet);
  int line_no;
  cycle_t time;

  // Cԍǂݍ
  line_no = param[0]; // 񖾎Icast

  if (line_no >= TL_ID_MAX)
  {
    // w肳ꂽCԍ݂Ȃꍇُ͈픻
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  // wTIǂݍ
  endian_memcpy(&time, packet + 1, sizeof(time));

  if (drop_tl_cmd_at_(line_no, time) == PH_SUCCESS)
  {
    return CCP_EXEC_SUCCESS;
  }
  else
  {
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }
}

static PH_ACK drop_tl_cmd_at_(int line_no, cycle_t time)
{
  int i;

  PL_Node* prev = NULL;
  PL_Node* current = (PL_Node*)PL_get_head(&(PH_tl_cmd_list[line_no])); // const_cast
  int active_nodes_num = PL_count_active_nodes(&PH_tl_cmd_list[line_no]);

  if (current == NULL) return PH_TLC_NOT_FOUND;

  for (i = 0; i < active_nodes_num; ++i)
  {
    if (CCP_get_ti(&(current->packet)) == time)
    {
      PL_drop_node(&(PH_tl_cmd_list[line_no]), prev, current);
      break;
    }
    if (PL_get_next(current) == NULL) return PH_TLC_NOT_FOUND;

    prev = current;
    current = current->next;
  }

  return PH_SUCCESS;
}


CCP_EXEC_STS Cmd_TLCD_SET_SOE_FLAG(const CTCP* packet)
{
  const unsigned char* param = CCP_get_param_head(packet);
  uint8_t line_no;
  uint8_t flag;

  // p[^ǂݏo&emF
  line_no = param[0];

  if (line_no >= TL_ID_MAX)
  {
    // w肳ꂽCԍ݂Ȃꍇُ͈픻B
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  flag = param[1];

  if ((flag != 0) && (flag != 1))
  {
    // tOe0/1łȂȂُ픻B
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  // ُ펞sftOݒ
  timeline_command_dispatcher_[line_no].stop_on_error = flag;
  return CCP_EXEC_SUCCESS;
}

CCP_EXEC_STS Cmd_TLCD_SET_LOUT_FLAG(const CTCP* packet)
{
  const unsigned char* param = CCP_get_param_head(packet);
  uint8_t line_no;
  uint8_t flag;

  // p[^ǂݏo&l`FbNB
  line_no = param[0];

  if (line_no >= TL_ID_MAX)
  {
    // ݂ȂCԍw肳ꂽꍇُ͈픻B
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  flag = param[1];

  if ((flag != 0) && (flag != 1))
  {
    // tO0/1łȂꍇُ͈픻B
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  // R}hstOݒB
  timeline_command_dispatcher_[line_no].lockout = flag;
  return CCP_EXEC_SUCCESS;
}

CCP_EXEC_STS Cmd_TLCD_SET_LINE_NO_FOR_TIMELINE_TLM(const CTCP* packet)
{
  int line_no;

  // Cԍǂݍ
  line_no = CCP_get_param_head(packet)[0];

  if (line_no >= TL_ID_MAX)
  {
    // w肳ꂽCԍ݂Ȃꍇُ͈픻
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  TLCD_line_no_for_tlm_ = line_no;

  return CCP_EXEC_SUCCESS;
}

CCP_EXEC_STS Cmd_TLCD_DEPLOY_BLOCK(const CTCP* packet)
{
  int      line_no;
  bct_id_t block_no;
  PL_ACK   ack;
  const uint8_t* param = CCP_get_param_head(packet);

  if (CCP_get_param_len(packet) != (1 + SIZE_OF_BCT_ID_T))
  {
    // p[^TLCԍ(1Byte)ƃubNԍB
    // vȂꍇُ͈픻B
    return CCP_EXEC_ILLEGAL_LENGTH;
  }

  // Cԍǂݍ
  line_no = param[0];

  if (line_no >= TL_ID_MAX)
  {
    // w肳ꂽCԍ݂Ȃꍇُ͈픻
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  endian_memcpy(&block_no, &param[1], SIZE_OF_BCT_ID_T);

  if (block_no >= BCT_MAX_BLOCKS)
  {
    // w肳ꂽubNԍ݂Ȃꍇُ͈픻
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  ack = PL_deploy_block_cmd(&(PH_tl_cmd_list[line_no]), block_no, (size_t)(TMGR_get_master_total_cycle()));

  if (ack != PL_SUCCESS)
  {
    EL_record_event((EL_GROUP)EL_CORE_GROUP_TLCD_DEPLOY_BLOCK,
                    (uint32_t)ack,
                    EL_ERROR_LEVEL_LOW,
                    (uint32_t)line_no);
    return CCP_EXEC_ILLEGAL_CONTEXT;
  }

  return CCP_EXEC_SUCCESS;
}

CCP_EXEC_STS Cmd_TLCD_SET_PAGE_FOR_TLM(const CTCP* packet)
{
  uint8_t page;

  page = CCP_get_param_head(packet)[0];

  if (page >= TL_TLM_PAGE_MAX)
  {
    // y[WԍR}he[u͈͊O
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  TLCD_page_no_ = page;
  return CCP_EXEC_SUCCESS;
}

CCP_EXEC_STS Cmd_TLCD_CLEAR_ERR_LOG(const CTCP* packet)
{
  uint8_t line_no;

  line_no = CCP_get_param_head(packet)[0];

  if (line_no >= TL_ID_MAX)
  {
    // CԍsB
    return CCP_EXEC_ILLEGAL_PARAMETER;
  }

  // YR}h@\̃G[L^B
  CDIS_clear_error_status(&timeline_command_dispatcher_[line_no]);
  return CCP_EXEC_SUCCESS;
}

#pragma section
