/**
 * @file spi.h
 * @brief SPIʐM(Master)̃bp[NXłB
 * @note SPIʐMbp[́A
 *       SPĨC^[tF[XA
 *       SPI|[g̏Af[^MAf[^MsA
 *       SPIʐMbp[̃NXłB
 *       X̋@̃C^[tF[XW[ɌpĎgp܂B
 */
#ifndef SPI_H_
#define SPI_H_

#include <src_user/Library/stdint.h>

 /**
  * @enum  SPI_MODE
  * @brief SPI샂[h̐ݒ
  * @note  ^uint8_tz
  */
typedef enum
{
  SPI_MODE_0 = 0,  //!< CPOL=0, CPHA = 0
  SPI_MODE_1 = 1,  //!< CPOL=0, CPHA = 1
  SPI_MODE_2 = 2,  //!< CPOL=1, CPHA = 0
  SPI_MODE_3 = 3,  //!< CPOL=1, CPHA = 1
} SPI_MODE;

/**
 * @enum  SPI_MODE
 * @brief SPI샂[h̐ݒ
 * @note  ^uint8_tz
 */
typedef enum
{
  SPI_TX_CS_STATE_LOW  = 0,   //!< MCSLoŵ܂܂ɂÂ܂܎MȂǂs
  SPI_TX_CS_STATE_HIGH = 1,   //!< MCSHighɂ
} SPI_TX_CS_STATE;

/**
 * @struct SPI_Config
 * @brief SPI|[g̏Af[^MEM̍ۂɕKvƂȂݒi[\̂łB
 */
typedef struct
{
  uint8_t  comm_ch;            //!< p̋@킪ȂĂʐM|[gԍ
  uint8_t  gpio_ch;            //!< p̋@킪ȂĂChip SelectpGPIO|[gԍ
  uint32_t frequency_khz;      //!< SPINbN̎g P:kHz
  SPI_MODE mode;               //!< SPI샂[h
  uint8_t  tx_data_for_rx;     //!< RX邽߂ɒIɑTXf[^
  uint16_t rx_length;          //!< Mf[^AMOɐݒ肷
  SPI_TX_CS_STATE tx_cs_state; //!< MChip SelectHighɂ邩ǂ̃tO
} SPI_Config;

/**
 * @enum  SPI_ERR_CODE
 * @brief SPIp̔ėpG[R[h
 * @note  ^int8_tz肵Ă邪, if_listŃbvĂ邽SPǏJ֐̕ԂlintƂȂĂ
 *        {Ȃ̂RX̕Ԃl͐Byte, G[R[hƂȂĂ邽
 */
typedef enum
{
  SPI_ERR_UNKNOWN = -20,          //!< s
  SPI_ERR_RX_BUFFER_SMALL = -14,  //!< Mobt@TCYMf[^菬
  SPI_ERR_DATA_NEGA = -13,        //!< Mf[^TCỸG[
  SPI_ERR_DATA_LARGE = -12,       //!< Mf[^TCY傫
  SPI_ERR_GPIO = -5,              //!< GPIO֘AG[
  SPI_ERR_YET = -4,               //!< `lI[v
  SPI_ERR_ALREADY = -3,           //!< `lI[vς
  SPI_ERR_FREQUENCY = -2,         //!< gُ
  SPI_ERR_CH = -1,                //!< `lُ (Port_configɖ)
  SPI_ERR_OK = 0,                 //!< OK0𓥏P
} SPI_ERR_CODE;

/**
 * @brief SPI_Config\̂O[oCX^XƂĒ`A|C^nƂŃ|[g܂B
 * @param[in] my_spi_v SPI_Config\̂ւ̃|C^
 * @return int SPI_ERR_CODEƂ, if_listintƓꂳĂB
 * @note SPIʐMbp[̃NXgp鎞͋NɕK{ĂB
 *       ̊֐sOSPI_Config\̓̐ݒlݒ肵ĂKv܂B
 */
int SPI_init(void* my_spi_v);

/**
 * @brief SPI_Config\̂ɂĎw肳ꂽchf[^M܂
 * @param[in] my_spi_v    : ΏۂƂSPI_Config\̂ւ̃|C^
 * @param[in] data_v      : Mf[^i[ւ̃|C^
 * @param[in] buffer_size : Mf[^i[̃obt@TCYASPIʐMɂMf[^Kv
 * @retval 0: Mf[^Ȃ
 * @retval : Mf[^oCg
 * @retval : G[. SPI_ERR_CODE ɏ]
 * @note ̊֐SPIǂݏov𑗐MĂ܂
 */
int SPI_rx(void* my_spi_v, void* data_v, int buffer_size);

/**
 * @brief SPI_Config\̂ɂĎw肳ꂽchփf[^𑗐M܂
 * @param[in] my_spi_v : ΏۂƂSPI_Config\̂ւ̃|C^
 * @param[in] data_v     : Mf[^i[ւ̃|C^
 * @param[in] count      : Mf[^TCY
 * @return int:  SPI_ERR_CODE ɏ]
 */
int SPI_tx(void* my_spi_v, void* data_v, int data_size);

/**
 * @brief w肳ꂽchJȂ
 * @param[in] my_spi_v JȂۂ̃|[gݒ
 * @param[in] reason   reopen闝RD0͐푀 TODO: reasonenumH
 * @return int:  SPI_ERR_CODE ɏ]
 */
int SPI_reopen(void* my_spi_v, int reason);

/**
 * @brief rx_lengthݒ肷
 * @param[in] my_spi_v  : ΏۂƂSPI_Config\̂ւ̃|C^
 * @param[in] rx_length : ݒ肷Mf[^
 * @return Ȃ
 */
void SPI_set_rx_length(void* my_spi_v, const uint16_t rx_length);

/**
 * @brief cs_up_after_txݒ肷
 * @param[in] my_spi_v       : ΏۂƂSPI_Config\̂ւ̃|C^
 * @param[in] tx_cs_state    : ݒ肷tx_cs_state
 * @return Ȃ
 */
void SPI_set_tx_cs_state(void* my_spi_v, const SPI_TX_CS_STATE tx_cs_state);

#endif
