/**
 * @file uart.h
 * @brief UARTʐMbp[̃NXłB
 * @note UARTC̓IɂUARTLVTTLz肵Ă
 *       UARTʐMbp[́A
 *       UART̃C^[tF[XA
 *       UART|[g̏Af[^MAf[^MsA
 *       UARTʐMbp[̃NXłB
 *       X̋@̃C^[tF[XW[ɌpĎgp܂B
 */

#ifndef UART_H_
#define UART_H_

#include <src_user/Library/stdint.h>

/**
 * @enum  PARITY_SETTINGS
 * @brief UART p̃peBݒ
 */
typedef enum
{
  PARITY_SETTINGS_NONE, //!< peB`FbNȂ
  PARITY_SETTINGS_ODD,  //!< peB
  PARITY_SETTINGS_EVEN, //!< peB
  PARITY_SETTINGS_MARK, //!< peB 1
  PARITY_SETTINGS_SPACE //!< peB 0
} PARITY_SETTINGS;

/**
 * @enum  UART_DATA_LENGTH
 * @brief UART f[^ (7 or 8)
 */
typedef enum
{
  UART_DATA_LENGTH_7BIT,
  UART_DATA_LENGTH_8BIT
} UART_DATA_LENGTH;

/**
 * @enum  UART_STOP_BIT
 * @brief UART Xgbvrbg
 */
typedef enum
{
  UART_STOP_BIT_1BIT,
  UART_STOP_BIT_15BIT,
  UART_STOP_BIT_2BIT
} UART_STOP_BIT;

/**
 * @enum  UART_ERR_CODE
 * @brief UARTp̔ėpG[R[h
 * @note  ^int8_tz肵Ă邪, if_listŃbvĂ邽UARŤJ֐̕ԂlintƂȂĂ
 *        {Ȃ̂RX̕Ԃl͐Byte, G[R[hƂȂĂ邽
 */
typedef enum
{
  UART_UNKNOWN_ERR     = -14, //!< s
  UART_DATA_NEGA_ERR   = -13, //!< Mf[^TCỸG[
  UART_FIFO_FULL_ERR   = -12, //!< TXɑMFIFOt
  UART_RX_ALL_ERR      = -11, //!< peB and FIFO and Xgbvrbg
  UART_FIFO_STOP_ERR   = -10, //!< FIFO and Xgbvrbg
  UART_PARITY_STOP_ERR = -9,  //!< peB and Xgbvrbg
  UART_STOP_BIT_ERR    = -8,  //!< XgbvrbgG[
  UART_PARITY_FIFO_ERR = -7,  //!< peB and FIFO
  UART_FIFO_OVER_ERR   = -6,  //!< FIFOI[o[
  UART_PARITY_ERR      = -5,  //!< peBG[
  UART_YET_ERR         = -4,  //!< `lI[v
  UART_ALREADY_ERR     = -3,  //!< `lI[vς
  UART_BAUDRATE_ERR    = -2,  //!< {[[gُ
  UART_CH_ERR          = -1,  //!< `lُ (Port_configɖ)
  UART_OK              = 0,   //!< OK0𓥏P
} UART_ERR_CODE;

/**
 * @struct UART_Config
 * @brief  UART|[g̏Af[^MAf[^M̍ۂɕKvƂȂݒi[\
 */
typedef struct
{
  uint8_t          ch;              //!< p̋@킪ȂĂ|[gԍ
  uint32_t         baudrate;        //!< p̋@̃{[[gl
  PARITY_SETTINGS  parity_settings; //!< peBݒ
  UART_DATA_LENGTH data_length;     //!< f[^
  UART_STOP_BIT    stop_bit;        //!< Xgbvrbg
} UART_Config;

/**
 * @brief UART_CONFIG\̂O[oCX^XƂĒ`, |C^nƂŃ|[g.
 * @param[in] my_uart_v UART_CONFIG\̂ւ̃|C^
 * @return int if_listintƓꂳĂ
 * @note UARTʐMbp[̃NXgp鎞͋NɕK{Ă.
 *       ̊֐sOUART_CONFIG\̓̐ݒlݒ肵ĂKv܂.
 */
int UART_init(void* my_uart_v);


/**
 * @brief UART_CONFIG\̂ɂĎw肳ꂽchf[^M܂
 * @param[in] my_uart_v   : ΏۂƂUART_CONFIG\̂ւ̃|C^
 * @param[in] data_v      : Mf[^i[ւ̃|C^
 * @param[in] buffer_size : Mf[^i[̃f[^TCY
 * @retval 0: Mf[^Ȃ
 * @retval : Mf[^oCg
 * @retval : G[. UART_ERR_CODE ɏ]
 */
int UART_rx(void* my_uart_v, void* data_v, int buffer_size);


/**
 * @brief UART_CONFIG\̂ɂĎw肳ꂽchփf[^𑗐M܂
 * @param[in] my_uart_v : ΏۂƂUART_CONFIG\̂ւ̃|C^
 * @param[in] data_v    : Mf[^i[ւ̃|C^
 * @param[in] data_size : Mf[^TCY
 * @return int:  UART_ERR_CODE ɏ]
 */
int UART_tx(void* my_uart_v, void* data_v, int data_size);


/**
 * @brief w肳ꂽchJȂ
 * @param[in] my_uart_v : JȂۂ̃|[gݒ
 * @param[in] reason    : repoen̗RR[hȂ
 */
int UART_reopen(void* my_uart_v, int reason);

#endif
