/**
 * @file  event_logger.h
 * @brief Am}G[Ȃǂ̊eCxgL^
 * @note  ̃CxgƂ event_handler 𔭉΂邱Ƃł
 * @note  O TLog (TimeSeriesLog)  CLog (EL_CumulativeLog) ̓ނCKvȂ݂̂̂g
 * @note  C NvLog (sLog) \
 * @note  TLog (TimeSeriesLog)
 *        n񃍃O
 *        ЂCV EL_Event e[uɒǋLĂD
 *        EL_get_the_nth_tlog_from_the_latest ōŐVnԖڂ擾łD
 *        LȂƁC event_handler ͎gȂD
 *        e[utɂȂꍇC㏑邩Ȃ is_enable_overwrite ɂđI\D
 * @note  CLog (EL_CumulativeLog)
 *        ݐσO
 *        EL_Event (EL_Event.group, EL_Event.local ɂē) Ƃ̗ݐσJE^ێCn\[gD
 *        e[utɂȂƍłÂ̂̂ĂD
 *        ȉ̂悤ȓ
 *          tH[}bg:
 *            | log index | event | counter | time | dt |
 *          1.  t1: event1 
 *             | 0 | event1 | 1 | t1 | 0 |
 *          2.  t2: event2 
 *             | 0 | event2 | 1 | t2 | 0 |
 *             | 1 | event1 | 1 | t1 | 0 |
 *          3.  t3: event2 
 *             | 0 | event2 | 2 | t3 | t3 - t2 |
 *             | 1 | event1 | 1 | t1 | 0       |
 *          4.  t4: event1 
 *             | 0 | event1 | 2 | t4 | t4 - t1 |
 *             | 1 | event2 | 2 | t3 | t3 - t2 |
 *          5.  t5: event3 
 *             | 0 | event3 | 1 | t5 | 0       |
 *             | 1 | event1 | 2 | t4 | t4 - t1 |
 *             | 2 | event2 | 2 | t3 | t3 - t2 |
 */
#ifndef EVENT_LOGGER_H_
#define EVENT_LOGGER_H_

// TODO: FALSH̑eʕs{[ւ̏
// TODO: AL  EL ̂̑ŜrhCȂׂ ifdef ǉî߁j
// TODO: ObcTime ̏ OBCT_clear ł͂Ȃ memset 0x00 łiȂCɂȂ邩j

#include <stddef.h>
#include <src_user/Library/stdint.h>
#include "../../CmdTlm/common_tlm_cmd_packet.h"
#include "../TimeManager/obc_time.h"

// EL_GROUP (uint32_t z) Œ`
#include <src_user/Settings/System/event_logger_group.h>

#define EL_TLOG_TLM_PAGE_SIZE         (32)    //!< TLogɂāCePy[Wɂ낹log
#define EL_TLOG_TLM_PAGE_MAX_HIGH     (4)     //!< TLogŕۑ郍Õy[W (EL_ERROR_LEVEL_HIGH)
#define EL_TLOG_TLM_PAGE_MAX_MIDDLE   (4)     //!< TLogŕۑ郍Õy[W (EL_ERROR_LEVEL_MIDDLE)
#define EL_TLOG_TLM_PAGE_MAX_LOW      (4)     //!< TLogŕۑ郍Õy[W (EL_ERROR_LEVEL_LOW)
#define EL_CLOG_TLM_PAGE_SIZE         (32)    //!< CLogɂāCePy[Wɂ낹log
#define EL_CLOG_TLM_PAGE_MAX_HIGH     (4)     //!< CLogŕۑ郍Õy[W (EL_ERROR_LEVEL_HIGH)
#define EL_CLOG_TLM_PAGE_MAX_MIDDLE   (4)     //!< CLogŕۑ郍Õy[W (EL_ERROR_LEVEL_MIDDLE)
#define EL_CLOG_TLM_PAGE_MAX_LOW      (4)     //!< CLogŕۑ郍Õy[W (EL_ERROR_LEVEL_LOW)

#define EL_TLOG_LOG_SIZE_MAX_EL       (16)    //!< TLogɂĕۑ郍O (EL_ERROR_LEVEL_EL)
#define EL_CLOG_LOG_SIZE_MAX_EL       (8)     //!< CLogɂĕۑ郍O (EL_ERROR_LEVEL_EL)

#define EL_IS_ENABLE_TLOG                     //!< TLog Lɂ邩H  ꂪȂ event_handler ͎gȂ
#define EL_IS_ENABLE_CLOG                     //!< CLog Lɂ邩H
// #define EL_IS_ENABLE_NVLOG                 //!< TODO: NvLog (sLog) Lɂ邩H
#define EL_IS_ENABLE_EVENT_NOTE               //!< EL_Event.note Lɂ邩H event ƂĂ (event_handler Ȃǂ) C⑫ʗp id gH
#define EL_IS_ENABLE_MIDDLE_ERROR_LEVEL       //!< EL_ERROR_LEVEL_MIDDLE Lɂ邩H iC2A coreł͎gȂ̂ŁC{OKDgȂLɁj
#define EL_IS_ENABLE_EL_ERROR_LEVEL           /*!< EL_ERROR_LEVEL_EL Lɂ邩H
                                                   ċAĂяo & [vh߂ɁCEL̃Cxg͕ʂ̐p̃G[xŋL^D
                                                   LƁCEL̃Am}L^łD */

#define SIZE_OF_EL_CLOG_COUNTER_T      (2)    //!< el_clog_counter_t ̌^TCYDCpNgȂɂ̂ŁCς

// ȉ event_logger_params.h ɂāCȉ̂悤Ȑݒ`DɃCpNĝ߂ɒ\ɂĂD
// ȂCƓmFĂ̂́CEL_IS_ENABLE_MIDDLE_ERROR_LEVEL ̂ݖȃ[ĥƂ
// #define EL_IS_ENABLE_TLOG: TLog LɂH
// #define EL_IS_ENABLE_CLOG: CLog LɂH
// #define EL_IS_ENABLE_EVENT_NOTE: EL_Event.note LɂH
// #define EL_IS_ENABLE_MIDDLE_ERROR_LEVEL: EL_ERROR_LEVEL_MIDDLE g悤ɂ邩H
// #define EL_IS_ENABLE_EL_ERROR_LEVEL: EL_ERROR_LEVEL_EL g悤ɂ邩H
// SIZE_OF_EL_CLOG_COUNTER_T: el_clog_counter_t ̌^TCY
// 㕔Œ`ĂCetableTCY
#include <src_user/Settings/System/event_logger_params.h>

#define EL_LOG_MINIMUM_REQUIRED           (2)   //!< Oɋ߂ŏvf
#define EL_LOG_MINIMUM_REQUIRED_EL_LOG    (4)   //!< ELOɋ߂ŏvf

#ifdef EL_IS_ENABLE_TLOG

#if EL_TLOG_TLM_PAGE_SIZE < EL_LOG_MINIMUM_REQUIRED
#error EL_TLOG_TLM_PAGE_SIZE must be >= EL_LOG_MINIMUM_REQUIRED
#endif

#define EL_TLOG_LOG_SIZE_MAX_HIGH     (EL_TLOG_TLM_PAGE_SIZE * EL_TLOG_TLM_PAGE_MAX_HIGH)
#if EL_TLOG_TLM_PAGE_MAX_HIGH <= 0
#error EL_TLOG_TLM_PAGE_MAX_HIGH must be a positive number
#endif
#ifdef EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
#define EL_TLOG_LOG_SIZE_MAX_MIDDLE   (EL_TLOG_TLM_PAGE_SIZE * EL_TLOG_TLM_PAGE_MAX_MIDDLE)
#if EL_TLOG_TLM_PAGE_MAX_MIDDLE <= 0
#error EL_TLOG_TLM_PAGE_MAX_MIDDLE must be a positive number
#endif
#else   // EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
#undef EL_TLOG_TLM_PAGE_MAX_MIDDLE
#endif  // EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
#define EL_TLOG_LOG_SIZE_MAX_LOW      (EL_TLOG_TLM_PAGE_SIZE * EL_TLOG_TLM_PAGE_MAX_LOW)
#if EL_TLOG_TLM_PAGE_MAX_LOW <= 0
#error EL_TLOG_TLM_PAGE_MAX_LOW must be a positive number
#endif

#ifdef EL_IS_ENABLE_EL_ERROR_LEVEL
#if EL_TLOG_LOG_SIZE_MAX_EL < EL_LOG_MINIMUM_REQUIRED_EL_LOG
#error EL_TLOG_LOG_SIZE_MAX_EL is too small
#endif
#else   // EL_IS_ENABLE_EL_ERROR_LEVEL
#undef EL_TLOG_LOG_SIZE_MAX_EL
#endif  // EL_IS_ENABLE_EL_ERROR_LEVEL

#else   // EL_IS_ENABLE_TLOG

#undef EL_TLOG_TLM_PAGE_SIZE
#undef EL_TLOG_TLM_PAGE_MAX_HIGH
#undef EL_TLOG_TLM_PAGE_MAX_MIDDLE
#undef EL_TLOG_TLM_PAGE_MAX_LOW
#undef EL_TLOG_LOG_SIZE_MAX_EL

#endif  // EL_IS_ENABLE_TLOG


#ifdef EL_IS_ENABLE_CLOG

#if EL_CLOG_TLM_PAGE_SIZE < EL_LOG_MINIMUM_REQUIRED
#error EL_CLOG_TLM_PAGE_SIZE must be >= EL_LOG_MINIMUM_REQUIRED
#endif

#define EL_CLOG_LOG_SIZE_MAX_HIGH     (EL_CLOG_TLM_PAGE_SIZE * EL_CLOG_TLM_PAGE_MAX_HIGH)
#if EL_CLOG_TLM_PAGE_MAX_HIGH <= 0
#error EL_CLOG_TLM_PAGE_MAX_HIGH must be a positive number
#endif
#ifdef EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
#define EL_CLOG_LOG_SIZE_MAX_MIDDLE   (EL_CLOG_TLM_PAGE_SIZE * EL_CLOG_TLM_PAGE_MAX_MIDDLE)
#if EL_CLOG_TLM_PAGE_MAX_MIDDLE <= 0
#error EL_CLOG_TLM_PAGE_MAX_MIDDLE must be a positive number
#endif
#else   // EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
#undef EL_CLOG_TLM_PAGE_MAX_MIDDLE
#endif  // EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
#define EL_CLOG_LOG_SIZE_MAX_LOW      (EL_CLOG_TLM_PAGE_SIZE * EL_CLOG_TLM_PAGE_MAX_LOW)
#if EL_CLOG_TLM_PAGE_MAX_LOW <= 0
#error EL_CLOG_TLM_PAGE_MAX_LOW must be a positive number
#endif

#ifdef EL_IS_ENABLE_EL_ERROR_LEVEL
#if EL_CLOG_LOG_SIZE_MAX_EL < EL_LOG_MINIMUM_REQUIRED_EL_LOG
#error EL_CLOG_LOG_SIZE_MAX_EL is too small
#endif
#else   // EL_IS_ENABLE_EL_ERROR_LEVEL
#undef EL_CLOG_LOG_SIZE_MAX_EL
#endif  // EL_IS_ENABLE_EL_ERROR_LEVEL

#if SIZE_OF_EL_CLOG_COUNTER_T == 1
typedef uint8_t el_clog_counter_t;
#elif SIZE_OF_EL_CLOG_COUNTER_T == 2
typedef uint16_t el_clog_counter_t;
#elif SIZE_OF_EL_CLOG_COUNTER_T == 4
typedef uint32_t el_clog_counter_t;
#else
#error Illegal value for SIZE_OF_EL_CLOG_COUNTER_T
#endif

#else    // EL_IS_ENABLE_CLOG

#undef EL_CLOG_TLM_PAGE_SIZE
#undef EL_CLOG_TLM_PAGE_MAX_HIGH
#undef EL_CLOG_TLM_PAGE_MAX_MIDDLE
#undef EL_CLOG_TLM_PAGE_MAX_LOW
#undef EL_CLOG_LOG_SIZE_MAX_EL

#endif  // EL_IS_ENABLE_CLOG


/**
 * @enum  EL_CORE_GROUP
 * @brief event_logger  Event Group  C2A core gp
 * @note  uint32_t z
 */
typedef enum
{
  EL_CORE_GROUP_NULL = 0,             //!< l or NULLD 0 ł邱Ƃv (clear  memset 0x00 Ȃ)
  EL_CORE_GROUP_EVENT_LOGGER,         //!< EL
  EL_CORE_GROUP_MODE_MANAGER,
  EL_CORE_GROUP_TASK_DISPATCHER,
  EL_CORE_GROUP_APP_MANAGER,
  EL_CORE_GROUP_TLCD_PAST_TIME,
  EL_CORE_GROUP_TLCD_DEPLOY_BLOCK,
  EL_CORE_GROUP_DCU,
  EL_CORE_GROUP_EVENT_HANDLER,
  // TODO: Driver Super
#ifdef EL_IS_ENABLE_EL_ERROR_LEVEL
  EL_CORE_GROUP_EL_DROP_CLOG1,        //!< EL CLogs ŌÂG[㏑Ƃ (group, err_level ۑ)
  EL_CORE_GROUP_EL_DROP_CLOG2,        //!< EL CLogs ŌÂG[㏑Ƃ (local, count ۑ)
#endif
  EL_CORE_GROUP_MAX
} EL_CORE_GROUP;


#ifdef EL_IS_ENABLE_EL_ERROR_LEVEL
/**
 * @enum  EL_EVENT_LOCAL
 * @brief EL_CORE_GROUP_EVENT_LOGGER  local id
 * @note  uint32_t z
 */
typedef enum
{
  EL_EVENT_LOCAL_UNKNOWN_ERR,             //!< s̃G[
#ifdef EL_IS_ENABLE_TLOG
  EL_EVENT_LOCAL_TLOG_HIGH_HALF_FULL,     //!< TLog ̃e[u̔܂ (HIGH)
  EL_EVENT_LOCAL_TLOG_HIGH_FULL,          //!< TLog ̃e[u܂Dwp͍ŏɖ߂CÂ̂㏑Ă (HIGH)
#ifdef EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
  EL_EVENT_LOCAL_TLOG_MIDDLE_HALF_FULL,   //!< TLog ̃e[u̔܂ (MIDDLE)
  EL_EVENT_LOCAL_TLOG_MIDDLE_FULL,        //!< TLog ̃e[u܂Dwp͍ŏɖ߂CÂ̂㏑Ă (MIDDLE)
#endif
  EL_EVENT_LOCAL_TLOG_LOW_HALF_FULL,      //!< TLog ̃e[u̔܂ (LOW)
  EL_EVENT_LOCAL_TLOG_LOW_FULL,           //!< TLog ̃e[u܂Dwp͍ŏɖ߂CÂ̂㏑Ă (LOW)
#endif
  EL_EVENT_LOCAL_MAX
} EL_EVENT_LOCAL;
#endif


/**
 * @enum  EL_ERROR_LEVEL
 * @brief event_logger  G[x
 * @note  uint8_t z
 * @note  C2A Core ł HIGH, LOW gȂ߁C MIDDLE ̓[U[`Ƃ
 */
typedef enum
{
  EL_ERROR_LEVEL_HIGH = 0,
#ifdef EL_IS_ENABLE_MIDDLE_ERROR_LEVEL
  EL_ERROR_LEVEL_MIDDLE,
#endif
  EL_ERROR_LEVEL_LOW,
#ifdef EL_IS_ENABLE_EL_ERROR_LEVEL
  EL_ERROR_LEVEL_EL,
#endif
  EL_ERROR_LEVEL_MAX
} EL_ERROR_LEVEL;


/**
 * @enum  EL_ACK
 * @brief event_logger ̔ėpԂl
 * @note  uint8_t z
 */
typedef enum
{
  EL_ACK_OK,                    //!< I
  EL_ACK_ILLEGAL_GROUP,         //!< s EL_Event.group
  EL_ACK_ILLEGAL_ERROR_LEVEL,   //!< s EL_Event.err_level
  EL_ACK_DISABLE_LOGGING,       //!< MOɂCp
  EL_ACK_TLOG_FULL,             //!< TLog̒ǋLs\̂߁CTLogL^ł
  EL_ACK_OTHER_ERR,             //!< ̑̃G[
} EL_ACK;


/**
 * @struct EL_Event
 * @brief  Cxg
 */
typedef struct
{
  EL_GROUP group;             //!< Cxg肷 group id
  uint32_t local;             /*!< ꂼ group Ƃɏڍ׏t^邽߂ id
                                   enumł悢CȂɂ̃G[R[hłǂCႦΏ݂sAhXCȂǂłǂ
                                   groupƂɒ` */
  EL_ERROR_LEVEL err_level;   //!< G[x
  ObcTime  time;              //!< 
#ifdef EL_IS_ENABLE_EVENT_NOTE
  uint32_t note;              /*!< Event  group, local œ肳邪Cɕ⑫ǉꍇɎgD
                                   event_handler Ȃǂł͖
                                   ⑫ǉꍇC event łꏊŋʂꍇɎgD */
#endif
} EL_Event;


/**
 * @struct EL_EventStatistics
 * @brief  Cxgv
 */
typedef struct
{
  uint32_t record_counter_total;                //!< CxgL^
  uint32_t record_counters[EL_ERROR_LEVEL_MAX]; //!< G[xƂ̋L^
} EL_EventStatistics;


#ifdef EL_IS_ENABLE_TLOG
/**
 * @struct EL_TimeSeriesLog
 * @brief  n񃍃O (TLog) ̃O\`
 */
typedef struct
{
  EL_Event* events;               //!< L^Cxge[uiTCYς̂߃|C^j
  uint16_t  log_capacity;         //!< Cxge[ũLpVeBiTCYj
  uint16_t  log_wp;               //!< Cxge[u write pointerD񏑂ݏꏊ
  uint8_t   is_enable_overwrite;  //!< TLog̏㏑邩HiftHgł͋j
  uint8_t   is_table_overflow;    //!< ㏑̏ꍇCĒǋLłȂH
} EL_TimeSeriesLog;
#endif


#ifdef EL_IS_ENABLE_CLOG
/**
 * @struct EL_CLogElement
 * @brief  ݐσO (CLog) ̂Pvf
 * note    group, local Cxg𓯈Ƃ݂Ȃ
 */
typedef struct
{
  EL_Event          event;                  //!< L^CxgƁCŌɋL^ꂽCxg
  el_clog_counter_t count;                  //!< ݐσJE^
  ObcTime           delta_record_time;      //!< ߂Q̃Cxg̍
} EL_CLogElement;


/**
 * @struct EL_CumulativeLog
 * @brief  ݐσO (CLog) ̃O\`
 */
typedef struct
{
  EL_CLogElement* logs;         //!< ݐσJE^ێCxge[uD[log_order[0]] ŐVDiTCYς̂߃|C^j
  uint16_t*       log_orders;   //!< logs n񏇂ɕёւ sort_keyiTCYς̂߃|C^j
  uint16_t        log_capacity; //!< Cxge[ũLpVeBiTCYj
} EL_CumulativeLog;
#endif


typedef struct
{
#ifdef EL_IS_ENABLE_TLOG
  struct
  {
    uint8_t page_no;            //!< tlm ŉ낷Oy[W
    EL_ERROR_LEVEL err_level;   //!< tlm ŉ낷̃G[x
  } tlog;
#endif
#ifdef EL_IS_ENABLE_CLOG
  struct
  {
    uint8_t page_no;            //!< tlm ŉ낷Oy[W
    EL_ERROR_LEVEL err_level;   //!< tlm ŉ낷̃G[x
  } clog;
#endif
} EL_TlmInfo;


typedef struct
{
#ifdef EL_IS_ENABLE_TLOG
  EL_TimeSeriesLog tlogs[EL_ERROR_LEVEL_MAX];
#endif
#ifdef EL_IS_ENABLE_CLOG
  EL_CumulativeLog clogs[EL_ERROR_LEVEL_MAX];
#endif

  EL_EventStatistics statistics;    //!< v
  EL_TlmInfo tlm_info;              //!< tlm̂߂̏

  uint8_t is_logging_enable[EL_GROUP_MAX / 8 + 1];  //!< LtOD팸̂߁C bit Pʂŕۑ

  EL_Event latest_event;
} EventLogger;


const extern EventLogger* const event_logger;


/**
 * @brief  event_logger ̏
 * @param  void
 * @return void
 */
void EL_initialize(void);

/**
 * @brief  Cxg (EL_Event) L^
 * @note   C2A ̔Cӂ̏ꏊ甭s\
 * @param  group: EL_Event.group
 * @param  local: EL_Event.local
 * @param  err_level: EL_Event.err_level EL_ERROR_LEVEL_EL ͋֎~
 * @param  note: EL_Event.note
 * @return EL_ACK
 */
EL_ACK EL_record_event(EL_GROUP group, uint32_t local, EL_ERROR_LEVEL err_level, uint32_t note);

/**
 * @brief  event_logger  EL_Event.group ̗L
 * @param  group: L EL_Event.group
 * @retval EL_ACK_OK: I
 * @retval EL_ACK_ILLEGAL_GROUP: s EL_Event.group
 */
EL_ACK EL_enable_logging(EL_GROUP group);

/**
 * @brief  event_logger  EL_Event.group ̖
 * @param  group:  EL_Event.group
 * @retval EL_ACK_OK: I
 * @retval EL_ACK_ILLEGAL_GROUP: s EL_Event.group
 */
EL_ACK EL_disable_logging(EL_GROUP group);

/**
 * @brief  event_logger  EL_Event.group LH
 * @param  group:  EL_Event.group
 * @retval 0:  or Ȉ
 * @retval 1: L
 */
int EL_is_logging_enable(EL_GROUP group);

/**
 * @brief  event_logger ̑S EL_Event.group ̗L
 * @param  void
 * @return void
 */
void EL_enable_all_logging(void);

/**
 * @brief  event_logger ̑S EL_Event.group ̖
 * @param  void
 * @return void
 */
void EL_disable_all_logging(void);

#ifdef EL_IS_ENABLE_TLOG
/**
 * @brief  TLog ̃Cxge[ȕ㏑L
 * @param  err_level: L EL_Event.err_level
 * @retval EL_ACK_OK: I
 * @retval EL_ACK_ILLEGAL_ERROR_LEVEL: s EL_Event.err_level
 */
EL_ACK EL_enable_tlog_overwrite(EL_ERROR_LEVEL err_level);

/**
 * @brief  TLog ̃Cxge[ȕ㏑𖳌
 * @param  err_level:  EL_Event.err_level
 * @retval EL_ACK_OK: I
 * @retval EL_ACK_ILLEGAL_ERROR_LEVEL: s EL_Event.err_level
 */
EL_ACK EL_disable_tlog_overwrite(EL_ERROR_LEVEL err_level);

/**
 * @brief  TLog ̃Cxge[ȕ㏑ׂėL
 * @param  void
 * @return void
 */
void EL_enable_tlog_overwrite_all(void);

/**
 * @brief  TLog ̃Cxge[ȕ㏑ׂĖ
 * @param  void
 * @return void
 */
void EL_disable_tlog_overwrite_all(void);

/**
 * @brief  TLog ̃Cxge[ȕ㏑LH
 * @param  err_level:  EL_Event.err_level
 * @retval 0:  or Ȉ
 * @retval 1: L
 */
int EL_is_tlog_overwrite_enable(EL_ERROR_LEVEL err_level);

/**
 * @brief  TLog ̃Cxge[u̍ŐVnԖڂ̃Cxg擾
 * @note   n 傫ꍇ́CŐV̂̂Ԃ
 * @note   err_level sȏꍇ́C EL_ERROR_LEVEL_HIGH ̂̂Ԃ
 * @note   ܂CAT[VG[oȂ
 * @param  err_level: 擾 EL_Event.err_level
 * @param  n: nԖځi0̂ƂŐVj
 * @return EL_Event
 */
const EL_Event* EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL err_level, uint16_t n);
#endif

CCP_EXEC_STS Cmd_EL_INIT(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_CLEAR_LOG_ALL(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_CLEAR_LOG_BY_ERR_LEVEL(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_CLEAR_STATISTICS(const CTCP* packet);

#ifdef EL_IS_ENABLE_TLOG
CCP_EXEC_STS Cmd_EL_CLEAR_TLOG(const CTCP* packet);
#endif

#ifdef EL_IS_ENABLE_CLOG
CCP_EXEC_STS Cmd_EL_CLEAR_CLOG(const CTCP* packet);
#endif

CCP_EXEC_STS Cmd_EL_RECORD_EVENT(const CTCP* packet);

#ifdef EL_IS_ENABLE_TLOG
CCP_EXEC_STS Cmd_EL_TLOG_SET_PAGE_FOR_TLM(const CTCP* packet);
#endif

#ifdef EL_IS_ENABLE_CLOG
CCP_EXEC_STS Cmd_EL_CLOG_SET_PAGE_FOR_TLM(const CTCP* packet);
#endif

CCP_EXEC_STS Cmd_EL_INIT_LOGGING_SETTINGS(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_ENABLE_LOGGING(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_DISABLE_LOGGING(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_ENABLE_LOGGING_ALL(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_DISABLE_LOGGING_ALL(const CTCP* packet);

#ifdef EL_IS_ENABLE_TLOG
CCP_EXEC_STS Cmd_EL_ENABLE_TLOG_OVERWRITE(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_DISABLE_TLOG_OVERWRITE(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_ENABLE_TLOG_OVERWRITE_ALL(const CTCP* packet);

CCP_EXEC_STS Cmd_EL_DISABLE_TLOG_OVERWRITE_ALL(const CTCP* packet);
#endif

#endif
