#pragma section REPRO
#include "c2a_core_main.h"

#include "./Library/print.h"
#include "./System/TaskManager/task_dispatcher.h"
#include "./System/ApplicationManager/app_manager.h"
#include "./System/EventManager/event_manager.h"
#include "./System/AnomalyLogger/anomaly_logger.h"
#include "./System/ModeManager/mode_manager.h"
#include "./System/WatchdogTimer/watchdog_timer.h"
#include "./CmdTlm/packet_handler.h"
#include "./CmdTlm/block_command_table.h"
#include "./CmdTlm/command_analyze.h"
#include "./CmdTlm/telemetry_frame.h"

#include <src_user/Applications/app_registry.h>

void C2A_core_init(void)
{
  CA_initialize();            // Cmd Analyze
  Printf("C2A_init: CA_initialize done.\n");
  TF_initialize();            // TLM frame
  Printf("C2A_init: TF_initialize done.\n");
  PH_init();                  // Packet Handler
  Printf("C2A_init: PH_init done.\n");
  EM_initialize();            // Event ManagerDApp Managerɏׂ
  Printf("C2A_init: EM_initialize done.\n");
  AL_initialize();            // Anomaly LoggerDApp Managerɏׂ
  Printf("C2A_init: AL_initialize done.\n");
  AM_initialize();            // App Manager
  Printf("C2A_init: AM_initialize done.\n");
  AR_load_initial_settings(); // App Registry
  Printf("C2A_init: AR_load_initial_settings done.\n");
  AM_initialize_all_apps();   // App Managerɓo^ĂSAv̏
  Printf("C2A_init: AM_initialize_all_apps done.\n");
  BCT_initialize();           // Block Cmd Table
                              // BC_load_defaults() ŌĂ΂
  Printf("C2A_init: BCT_initialize done.\n");
  MM_initialize();            // Mode Manager
                              // START UP to INITIAL̃[hJڂs
  Printf("C2A_init: MM_initialize done.\n");
  TDSP_initialize();          // Task Dispatcher
                              // MMƂɍsKv
  Printf("C2A_init: TDSP_initialize done.\n");
  // DebugOutInit();             // Debuginit          // LVTTL UART ch1ł̏óDזȂ̂Printf̒gƂƂɖ (2019-04-09)
  // Printf("C2A_init: DebugOutInit done.\n");
}

void C2A_core_main(void)
{
  // 2018/09/09 RgǋL
  // łtask dispatcheŕCTL0Ƃł͂ȂC
  // task listBlockCommanddispatchĂD
  // TL0ȂǂPLdispatchĂ̂́Ctlc_dispatcher @ App/timeline_command_dispatcher łD
  // ȂCPL (packetList) PL_infoƂ́CdispatchĂpPbgnɂȂׂlinked listłD
  TDSP_execute_pl_as_task_list();
  WDT_clear_wdt();
}

#pragma section
